-- (c) 2006 Witold Bolt (ja@hope.art.pl)

-- wiekoszosc funkcji z pliku funkcje.sql nalezy traktowac rowniez jako przyklady
-- zapytan ... tu umieszczono tylko kilka zapytan takich ktore trudno
-- logicznie zmiescic w nowa funkcje

-- wyswietla tytuly ksiazek ktore maja poszczegolni uzytkownicy oraz
-- ile egzemplarzy danej ksiazki maja ..
SELECT ku.login,ksiazka.tytul,count(ksiazka.tytul) from
    ksiazka inner join (select kid,uzytkownik.login from
            egzemplarz inner join uzytkownik on egzemplarz.uid=uzytkownik.id)
            as ku on ksiazka.id=ku.kid
    group by ku.login,ksiazka.tytul order by login;

-- ilu uzytkownikow wypozyczylo juz dany egzemplarz ?
SELECT egzemplarz.id,count(historia.uid) FROM egzemplarz,historia
    WHERE egzemplarz.id=historia.eid GROUP BY egzemplarz.id;

-- ile jest egzemplarzy kazdej z ksiazek ktore moga byc wypozyczone
-- przez uzytkownika z id = 1
SELECT ksiazka.autor,ksiazka.tytul,count(egzemplarz.id) FROM egzemplarz
INNER JOIN ksiazka ON egzemplarz.kid = ksiazka.id
WHERE ( SELECT count(*) FROM getEgzemplarzByBookUser(ksiazka.id,1) ) > 0
AND egzemplarz.uid <> 1
GROUP BY ksiazka.autor,ksiazka.tytul;


-- wybieramy login uzytkownika ktory najdluzej trzymal ksiazke
-- wraz z liczba dni (niestety zapytanie nie jest doskonale bo nie radzi
-- sobie ze zliczeniem osob ktore jeszcze nie oddaly ksiazki a byc
-- moze juz przekroczyly najdluzszy czas)
SELECT uzytkownik.login,wypozyczenieLen(historia.id) AS ile_dni
FROM uzytkownik INNER JOIN historia
ON uzytkownik.id=historia.uid
ORDER BY ile_dni DESC LIMIT 1;
